/*	DRS/NX 300	@(#)rain.c	4.1	10/14/88	*/
/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*#ident	"@(#)libcurses:demo/rain.c	1.2"*/
#define MINICURSES
#include <curses.h>
#include <signal.h>
/* rain 11/3/1980 EPS/CITHEP */

#define cursor(col,row) move(row,col)
main(argc,argv)
int argc;
char *argv[];
{
    char *malloc();
#ifdef GENERIC
    float ranf();
#endif
    int onsig();
    register int x, y, j;
    static int xpos[5], ypos[5];
    setbuf(stdout,malloc(BUFSIZ));

    for (j=SIGHUP;j<=SIGTERM;j++)
	if (signal(j,SIG_IGN)!=SIG_IGN) signal(j,onsig);

    initscr();
    nl();
    noecho();
    for (j=5;--j>=0;) {
#ifdef GENERIC
	xpos[j]=(int)(76.*ranf())+2;
	ypos[j]=(int)(20.*ranf())+2;
#else
	xpos[j]=(int)(rand() % (COLS-4))+2;
	ypos[j]=(int)(rand() % (LINES-4))+2;
#endif
    }
    for (j=0;;) {
#ifdef GENERIC
	x=(int)(76.*ranf())+2;
	y=(int)(20.*ranf())+2;
#else
	x=(int)(rand() % (COLS-4))+2;
	y=(int)(rand() % (LINES-4))+2;
#endif

	cursor(x,y); addch((chtype)'.');

	cursor(xpos[j],ypos[j]); addch((chtype)'o');

	if (j==0) j=4; else --j;
	cursor(xpos[j],ypos[j]); addch((chtype)'O');

	if (j==0) j=4; else --j;
	cursor(xpos[j],ypos[j]-1);
	addch((chtype)'-');
	cursor(xpos[j]-1,ypos[j]);
	addstr("|.|");
	cursor(xpos[j],ypos[j]+1);
	addch((chtype)'-');

	if (j==0) j=4; else --j;
	cursor(xpos[j],ypos[j]-2);
	addch((chtype)'-');
	cursor(xpos[j]-1,ypos[j]-1);
	addstr("/ \\");
	cursor(xpos[j]-2,ypos[j]);
	addstr("| O |");
	cursor(xpos[j]-1,ypos[j]+1);
	addstr("\\ /");
	cursor(xpos[j],ypos[j]+2);
	addch((chtype)'-');

	if (j==0) j=4; else --j;
	cursor(xpos[j],ypos[j]-2);
	addch((chtype)' ');
	cursor(xpos[j]-1,ypos[j]-1);
	addstr("   ");
	cursor(xpos[j]-2,ypos[j]);
	addstr("     ");
	cursor(xpos[j]-1,ypos[j]+1);
	addstr("   ");
	cursor(xpos[j],ypos[j]+2);
	addch((chtype)' ');
	xpos[j]=x; ypos[j]=y;
	refresh();
    }
}

onsig(n)
int n;
{
    endwin();
    exit(0);
}

#ifdef GENERIC
float
ranf()
{
    float rv;
    long r = rand();

    r &= 077777;
    rv =((float)r/32767.);
    return rv;
}
#endif
